"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const reob = require("../../src/reob");
const Tests = require("./Tests");
let TestTree = class TestTree {
    constructor(initialHeight) {
        this.height = 10;
        this.someArray = [];
        this.someBoolean = false;
        this.leaves = [];
        this.height = initialHeight || 10;
        this.creationDate = new Date();
    }
    grow() {
        return this._grow();
    }
    _grow() {
        this.height++;
        //console.log("Tree is growing to new heights: ", this.height+" on the "+(omm.getMeteor().isServer?"server":"client"));
        this.leaves.push(new Tests.TestLeaf("leaf" + this.getHeight(), this));
        this.leaves.forEach(function (l) {
            l.grow();
        });
        return "grown!";
    }
    growAsOnlyACollectionUpdate() {
        return this._grow();
    }
    wither() {
        this.leaves = [];
        reob.emit("gardenevents", "withered");
        reob.emit("gardenevents", "withered2");
    }
    thisThrowsAnError() {
        throw new Error("Hello world");
    }
    getHeight() {
        return this.height;
    }
    getLeaves() {
        return this.leaves;
    }
    setSomeBooleanTo(f) {
        this.someBoolean = f;
        reob.emit("gardenevents", "someBoolean");
        return "set to " + f;
    }
    growAndReturnLeaves() {
        this.grow();
        return this.leaves;
    }
};
__decorate([
    reob.Id
], TestTree.prototype, "treeId", void 0);
__decorate([
    reob.ArrayType("TestLeaf"),
    reob.DocumentName('thoseGreenThings')
], TestTree.prototype, "leaves", void 0);
__decorate([
    reob.Type("TestAddress")
    // @omm.AsForeignKey
], TestTree.prototype, "address", void 0);
__decorate([
    reob.RemoteCollectionUpdate
], TestTree.prototype, "grow", null);
__decorate([
    reob.CollectionUpdate
], TestTree.prototype, "growAsOnlyACollectionUpdate", null);
__decorate([
    reob.RemoteCollectionUpdate
], TestTree.prototype, "wither", null);
__decorate([
    reob.RemoteCollectionUpdate
], TestTree.prototype, "thisThrowsAnError", null);
__decorate([
    reob.CollectionUpdate
], TestTree.prototype, "setSomeBooleanTo", null);
__decorate([
    reob.CollectionUpdate,
    reob.Remote({ replaceWithCall: true, resultType: "TestLeaf" })
], TestTree.prototype, "growAndReturnLeaves", null);
TestTree = __decorate([
    reob.Entity
], TestTree);
exports.TestTree = TestTree;
//# sourceMappingURL=TestTree.js.map