"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by bert on 07.10.16.
 */
const Tests = require("./Tests");
const reob = require("../../src/reob");
class TreeServiceServer {
    constructor(ttc, tpc, request) {
        this.request = request;
        this.treeCollection = ttc;
        this.personCollection = tpc;
        console.log("instantiated tree service with request", request);
    }
    insertTree(height) {
        var t = new Tests.TestTree(height);
        return this.treeCollection.insert(t, this.request).then((id) => {
            return t;
        });
    }
    growTree(treeId) {
        return this.treeCollection.getById(treeId, this.request).then((t) => {
            return t.growAsOnlyACollectionUpdate();
        });
    }
    setSomeBooleanOnTree(treeId, b) {
        return this.treeCollection.getByIdOrFail(treeId, this.request).then((t) => {
            return t.setSomeBooleanTo(b);
        }).then((s) => {
            return "added in the service:" + s;
        });
    }
    aTreeAndAPerson(treeId, personId) {
        return Promise.all([this.treeCollection.getByIdOrFail(treeId, this.request), this.personCollection.getByIdOrFail(personId, this.request)]);
    }
    removeTree(treeId) {
        return this.treeCollection.deleteTree(treeId, this.request);
    }
}
__decorate([
    reob.Remote({ serverOnly: true })
], TreeServiceServer.prototype, "insertTree", null);
__decorate([
    reob.Remote({ serverOnly: true })
], TreeServiceServer.prototype, "growTree", null);
__decorate([
    reob.Remote({ serverOnly: true })
], TreeServiceServer.prototype, "setSomeBooleanOnTree", null);
__decorate([
    reob.Remote({ serverOnly: true })
], TreeServiceServer.prototype, "aTreeAndAPerson", null);
__decorate([
    reob.Remote({ serverOnly: true })
], TreeServiceServer.prototype, "removeTree", null);
exports.TreeServiceServer = TreeServiceServer;
//# sourceMappingURL=TreeServiceServer.js.map